#include <bits/stdc++.h>

#define int long long

using namespace std;

signed main()
{
   ios::sync_with_stdio(false);
   cin.tie(0);
   int n, k;
   cin >> n >> k;
   vector<int> a(n + 1);
   for(int i = 1; i <= n; i++) {
    char x;
    cin >> x;
    a[i] = x - 'a';
   }
   string c = "";
   map<int,int> M;
   map<int,int> M1;
   map<int,int> M2;
   for(int i = 1; i <= n; i++) {
        M[a[i]] += 1;
        int ans = k;
        for(int j = 0; j < k; j++) {
            ans = min(ans, M[j] + 1);
        }
        cout << ans << " ";
   }
}